'''
Create all test files needed to perform the SVM training test
described in section 6.2 of the manuscript

   R. Cominetti, W. F. Mascarenhas, and Paulo J. S. Silva. "A
   Newton method for the continuous quadratic knapsack problem".
'''

from subprocess import call
from platform import architecture
import scipy as sp
from convert_to_svm import save_for_train

# Prepapre Adult and MNIST data
call(['python', 'prepare_adult.py'])
call(['python', 'prepare_mnist.py'])
    
# Save kernel matrix form many variations of the data sets.
save_for_train('adult.svm.npz', 712, 353, sp.sqrt(10.0), 
               'adult_01065.svm', False)
save_for_train('adult.svm.npz', 1514, 751, sp.sqrt(10.0), 'adult_02265.svm', 
               False)
save_for_train('adult.svm.npz', 2129, 1056, sp.sqrt(10.0), 'adult_03185.svm', 
               False)
save_for_train('adult.svm.npz', 4258, 2112, sp.sqrt(10.0), 'adult_06370.svm', 
               False)
save_for_train('adult.svm.npz', 8516, 4224, sp.sqrt(10.0), 'adult_12740.svm', 
	       True)
save_for_train('mnist.svm.npz', 400, 400, 5.0, 'mnist_00800.svm', False)
save_for_train('mnist.svm.npz', 800, 800, 5.0, 'mnist_01600.svm', False)
save_for_train('mnist.svm.npz', 1600, 1600, 5.0, 'mnist_03200.svm', False)
save_for_train('mnist.svm.npz', 3200, 3200, 5.0, 'mnist_06400.svm', False)
save_for_train('mnist.svm.npz', 5851, 5851, 5.0, 'mnist_11702.svm', True)
